## samba4 4.0.3+dfsg1

=== wscript ===
#! /usr/bin/env python

srcdir = '.'
blddir = 'bin'

APPNAME='samba'
VERSION=None

import sys, os, tempfile
sys.path.insert(0, srcdir+"/buildtools/wafsamba")
import wafsamba, Options, samba_dist, Scripting, Utils, samba_version


samba_dist.DIST_DIRS('.')
samba_dist.DIST_BLACKLIST('.gitignore .bzrignore source4/selftest/provisions/alpha13')

# install in /usr/local/samba by default
Options.default_prefix = '/usr/local/samba'

# This callback optionally takes a list of paths as arguments:
# --with-system_mitkrb5 /path/to/krb5 /another/path
def system_mitkrb5_callback(option, opt, value, parser):
    setattr(parser.values, option.dest, True)
    value = []
    for arg in parser.rargs:
        # stop on --foo like options
        if arg[:2] == "--" and len(arg) > 2:
            break
        value.append(arg)
    if len(value)>0:
        del parser.rargs[:len(value)]
        setattr(parser.values, option.dest, value)

def set_options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('samba4')
    opt.RECURSE('lib/replace')
    opt.RECURSE('dynconfig')
    opt.RECURSE('lib/ldb')
    opt.RECURSE('lib/ntdb')
    opt.RECURSE('selftest')
    opt.RECURSE('source4/lib/tls')
    opt.RECURSE('lib/nss_wrapper')
    opt.RECURSE('lib/socket_wrapper')
    opt.RECURSE('lib/uid_wrapper')
    opt.RECURSE('pidl')
    opt.RECURSE('source3')
    opt.RECURSE('lib/util')

    opt.add_option('--with-system-mitkrb5',
                   help='enable system MIT krb5 build (includes Samba 4 client and Samba 3 code base).'+
                        'You may specify list of paths where Kerberos is installed (e.g. /usr/local /usr/kerberos) to search krb5-config',
                   action='callback', callback=system_mitkrb5_callback, dest='with_system_mitkrb5', default=False)

    opt.add_option('--without-ad-dc',
                   help='disable AD DC functionality (enables Samba 4 client and Samba 3 code base).',
                   action='store_true', dest='without_ad_dc', default=False)

    gr = opt.option_group('developer options')

    opt.add_option('--disable-ntdb',
                   help=("disable ntdb"),
                   action="store_true", dest='disable_ntdb', default=True)


    opt.tool_options('python') # options for disabling pyc or pyo compilation
    # enable options related to building python extensions


def configure(conf):
    version = samba_version.load_version(env=conf.env)

    conf.DEFINE('CONFIG_H_IS_FROM_SAMBA', 1)
    conf.DEFINE('_SAMBA_BUILD_', version.MAJOR, add_to_cflags=True)
    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    if Options.options.developer:
        conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')
        conf.env.DEVELOPER = True

    conf.ADD_EXTRA_INCLUDES('#include/public #source4 #lib #source4/lib #source4/include #include #lib/replace')

    conf.RECURSE('lib/replace')

    conf.find_program('python', var='PYTHON', mandatory=True)
    conf.find_program('perl', var='PERL', mandatory=True)
    conf.find_program('xsltproc', var='XSLTPROC')

    # enable tool to build python extensions
    conf.check_tool('python')
    conf.check_python_version((2,4,2))
    conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=True)

    if sys.platform == 'darwin' and not conf.env['HAVE_ENVIRON_DECL']:
        # Mac OSX needs to have this and it's also needed that the python is compiled with this
        # otherwise you face errors about common symbols
        if not conf.CHECK_SHLIB_W_PYTHON("Checking if -fno-common is needed"):
            conf.ADD_CFLAGS('-fno-common')
        if not conf.CHECK_SHLIB_W_PYTHON("Checking if -undefined dynamic_lookup is not need"):
            conf.env.append_value('shlib_LINKFLAGS', ['-undefined', 'dynamic_lookup'])

    if sys.platform == 'darwin':
        conf.ADD_LDFLAGS('-framework CoreFoundation')

    if int(conf.env['PYTHON_VERSION'][0]) >= 3:
        raise Utils.WafError('Python version 3.x is not supported by Samba yet')

    conf.RECURSE('dynconfig')
    conf.RECURSE('lib/ldb')

    if Options.options.with_system_mitkrb5:
        conf.PROCESS_SEPARATE_RULE('system_mitkrb5')
    if not (Options.options.without_ad_dc or Options.options.with_system_mitkrb5):
        conf.DEFINE('AD_DC_BUILD_IS_ENABLED', 1)
    # Only process heimdal_build for non-MIT KRB5 builds
    # When MIT KRB5 checks are done as above, conf.env.KRB5_VENDOR will be set
    # to the lowcased output of 'krb5-config --vendor'.
    # If it is not set or the output is 'heimdal', we are dealing with
    # system-provided or embedded Heimdal build
    if conf.CONFIG_GET('KRB5_VENDOR') in (None, 'heimdal'):
        conf.RECURSE('source4/heimdal_build')
    conf.RECURSE('source4/lib/tls')
    conf.RECURSE('source4/ntvfs/sysdep')
    conf.RECURSE('lib/util')
    conf.RECURSE('lib/ccan')
    conf.env.disable_ntdb = getattr(Options.options, 'disable_ntdb', False)
    if not Options.options.disable_ntdb:
        conf.RECURSE('lib/ntdb')
    else:
        conf.DEFINE('DISABLE_NTDB', 1)
    conf.RECURSE('lib/zlib')
    conf.RECURSE('lib/util/charset')
    conf.RECURSE('source4/auth')
    conf.RECURSE('lib/nss_wrapper')
    conf.RECURSE('nsswitch')
    conf.RECURSE('lib/socket_wrapper')
    conf.RECURSE('lib/uid_wrapper')
    conf.RECURSE('lib/popt')
    conf.RECURSE('lib/iniparser/src')
    conf.RECURSE('lib/subunit/c')
    conf.RECURSE('libcli/smbreadline')
    conf.RECURSE('lib/crypto')
    conf.RECURSE('pidl')
    conf.RECURSE('selftest')
    conf.RECURSE('source3')

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

    # gentoo always adds this. We want our normal build to be as
    # strict as the strictest OS we support, so adding this here
    # allows us to find problems on our development hosts faster.
    # It also results in faster load time.

    if sys.platform != "openbsd4":
        conf.env.asneeded_ldflags = conf.ADD_LDFLAGS('-Wl,--as-needed', testflags=True)

    if not conf.CHECK_NEED_LC("-lc not needed"):
        conf.ADD_LDFLAGS('-lc', testflags=False)

    # we don't want PYTHONDIR in config.h, as otherwise changing
    # --prefix causes a complete rebuild
    del(conf.env.defines['PYTHONDIR'])
    del(conf.env.defines['PYTHONARCHDIR'])

    if not conf.CHECK_CODE('#include "tests/summary.c"',
                           define='SUMMARY_PASSES',
                           addmain=False,
                           execute=True,
                           msg='Checking configure summary'):
        raise Utils.WafError('configure summary failed')
    
    conf.SAMBA_CONFIG_H('include/config.h')


def etags(ctx):
    '''build TAGS file using etags'''
    import Utils
    source_root = os.path.dirname(Utils.g_module.root_path)
    cmd = 'rm -f %s/TAGS && (find %s -name "*.[ch]" | egrep -v \.inst\. | xargs -n 100 etags -a)' % (source_root, source_root)
    print("Running: %s" % cmd)
    os.system(cmd)

def ctags(ctx):
    "build 'tags' file using ctags"
    import Utils
    source_root = os.path.dirname(Utils.g_module.root_path)
    cmd = 'ctags --python-kinds=-i $(find %s -name "*.[ch]" | grep -v "*_proto\.h" | egrep -v \.inst\.) $(find %s -name "*.py")' % (source_root, source_root)
    print("Running: %s" % cmd)
    os.system(cmd)

# putting this here enabled build in the list
# of commands in --help
def build(bld):
    '''build all targets'''
    samba_version.load_version(env=bld.env, is_install=bld.is_install)
    pass


def pydoctor(ctx):
    '''build python apidocs'''
    bp = os.path.abspath('bin/python')
    mpaths = {}
    for m in ['talloc', 'tdb', 'ldb', 'ntdb']:
        f = os.popen("PYTHONPATH=%s python -c 'import %s; print %s.__file__'" % (bp, m, m), 'r')
        try:
            mpaths[m] = f.read().strip()
        finally:
            f.close()
    cmd='PYTHONPATH=%s pydoctor --introspect-c-modules --project-name=Samba --project-url=http://www.samba.org --make-html --docformat=restructuredtext --add-package bin/python/samba --add-module %s --add-module %s --add-module %s' % (
        bp, mpaths['tdb'], mpaths['ldb'], mpaths['talloc'], mpaths['ntdb'])
    print("Running: %s" % cmd)
    os.system(cmd)


def pep8(ctx):
    '''run pep8 validator'''
    cmd='PYTHONPATH=bin/python pep8 -r bin/python/samba'
    print("Running: %s" % cmd)
    os.system(cmd)


def wafdocs(ctx):
    '''build wafsamba apidocs'''
    from samba_utils import recursive_dirlist
    os.system('pwd')
    list = recursive_dirlist('../buildtools/wafsamba', '.', pattern='*.py')

    cmd='PYTHONPATH=bin/python pydoctor --project-name=wafsamba --project-url=http://www.samba.org --make-html --docformat=restructuredtext'
    print(list)
    for f in list:
        cmd += ' --add-module %s' % f
    print("Running: %s" % cmd)
    os.system(cmd)


def dist():
    '''makes a tarball for distribution'''
    sambaversion = samba_version.load_version(env=None)

    os.system(srcdir + "/release-scripts/build-manpages-nogit")
    samba_dist.DIST_FILES('bin/docs:docs', extend=True)

    os.system(srcdir + "/source3/autogen.sh")
    samba_dist.DIST_FILES('source3/configure', extend=True)
    samba_dist.DIST_FILES('source3/autoconf', extend=True)
    samba_dist.DIST_FILES('source3/include/autoconf', extend=True)
    samba_dist.DIST_FILES('examples/VFS/configure', extend=True)
    samba_dist.DIST_FILES('examples/VFS/module_config.h.in', extend=True)

    if sambaversion.IS_SNAPSHOT:
        # write .distversion file and add to tar
        if not os.path.isdir(blddir):
            os.makedirs(blddir)
        distversionf = tempfile.NamedTemporaryFile(mode='w', prefix='.distversion',dir=blddir)
        for field in sambaversion.vcs_fields:
            distveroption = field + '=' + str(sambaversion.vcs_fields[field])
            distversionf.write(distveroption + '\n')
        distversionf.flush()
        samba_dist.DIST_FILES('%s:.distversion' % distversionf.name, extend=True)

        samba_dist.dist()
        distversionf.close()
    else:
        samba_dist.dist()


def distcheck():
    '''test that distribution tarball builds and installs'''
    samba_version.load_version(env=None)
    import Scripting
    d = Scripting.distcheck
    d()

def wildcard_cmd(cmd):
    '''called on a unknown command'''
    from samba_wildcard import run_named_build_task
    run_named_build_task(cmd)

def main():
    from samba_wildcard import wildcard_main
    wildcard_main(wildcard_cmd)
Scripting.main = main

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)

=== dynconfig/wscript ===
#!/usr/bin/env python

import string, Logs, Utils, Options, sys, Build, os, intltool, optparse, textwrap
from samba_utils import EXPAND_VARIABLES, os_path_relpath

class SambaIndentedHelpFormatter (optparse.IndentedHelpFormatter):
    """Format help with indented section bodies.
    """

    def __init__(self,
                 indent_increment=2,
                 max_help_position=12,
                 width=None,
                 short_first=1):
        optparse.IndentedHelpFormatter.__init__(
            self, indent_increment, max_help_position, width, short_first)

    def format_option(self, option):
        # The help for each option consists of two parts:
        #   * the opt strings and metavars
        #     eg. ("-x", or "-fFILENAME, --file=FILENAME")
        #   * the user-supplied help string
        #     eg. ("turn on expert mode", "read data from FILENAME")
        #
        # If possible, we write both of these on the same line:
        #   -x      turn on expert mode
        #
        # But if the opt string list is too long, we put the help
        # string on a second line, indented to the same column it would
        # start in if it fit on the first line.
        #   -fFILENAME, --file=FILENAME
        #           read data from FILENAME
        result = []
        opts = self.option_strings[option]
        opt_width = self.help_position - self.current_indent - 2
        if len(opts) > opt_width:
            opts = "%*s%s\n" % (self.current_indent, "", opts)
            indent_first = self.help_position
        else:                       # start help on same line as opts
            opts = "%*s%-*s  " % (self.current_indent, "", opt_width, opts)
            indent_first = 0
        result.append(opts)
        if option.help:
            help_text = self.expand_default(option)
            if string.find(help_text, '\n') == -1:
                help_lines = textwrap.wrap(help_text, self.help_width)
            else:
                help_lines = help_text.splitlines()
            result.append("%*s%s\n" % (indent_first, "", help_lines[0]))
            result.extend(["%*s%s\n" % (self.help_position, "", line)
                           for line in help_lines[1:]])
        elif opts[-1] != "\n":
            result.append("\n")
        return "".join(result)


# list of directory options to offer in configure
#
# 'STD-PATH'  - the default path without --enable-fhs
# 'FHS-PATH'  - the default path with --enable-fhs
#
# 'OPTION'    - the configure option to overwrite the default (optional)
# 'HELPTEXT'  - the help text of the configure option (optional)
#
# 'OVERWRITE' - The option referrs to itself and was already from
#               the basic GNU options from the gnu_dirs tool.
#               We may overwrite the related path. (Default: False)
#
# 'DELAY'     - The option referrs to other options in the dynconfig list.
#               We delay the intialization into a later stage. This
#               makes sure the recursion works. (Default: False)
#
dynconfig = {
    'BINDIR' : {
         'STD-PATH':  '${BINDIR}',
         'FHS-PATH':  '${BINDIR}',
         'OVERWRITE': True,
    },
    'SBINDIR' : {
         'STD-PATH':  '${SBINDIR}',
         'FHS-PATH':  '${SBINDIR}',
         'OVERWRITE': True,
    },
    'LIBDIR' : {
         'STD-PATH':  '${LIBDIR}',
         'FHS-PATH':  '${LIBDIR}',
         'OVERWRITE': True,
    },
    'LIBEXECDIR' : {
         'STD-PATH':  '${LIBEXECDIR}',
         'FHS-PATH':  '${LIBEXECDIR}',
         'OVERWRITE': True,
    },
    'DATADIR' : {
         'STD-PATH':  '${DATADIR}',
         'FHS-PATH':  '${DATADIR}',
         'OVERWRITE': True,
    },
    'LOCALEDIR' : {
         'STD-PATH':  '${LOCALEDIR}',
         'FHS-PATH':  '${LOCALEDIR}',
         'OVERWRITE': True,
    },
    'PYTHONDIR' : {
         'STD-PATH':  '${PYTHONDIR}',
         'FHS-PATH':  '${PYTHONDIR}',
         'OVERWRITE': True,
    },
    'PYTHONARCHDIR' : {
         'STD-PATH':  '${PYTHONARCHDIR}',
         'FHS-PATH':  '${PYTHONARCHDIR}',
         'OVERWRITE': True,
    },
    'INCLUDEDIR' : {
         'STD-PATH':  '${INCLUDEDIR}',
         'FHS-PATH':  '${INCLUDEDIR}/samba-4.0',
         'OVERWRITE': True,
    },
    'SCRIPTSBINDIR' : {
         'STD-PATH':  '${SBINDIR}',
         'FHS-PATH':  '${SBINDIR}',
    },
    'SETUPDIR' : {
         'STD-PATH':  '${DATADIR}/setup',
         'FHS-PATH':  '${DATADIR}/samba/setup',
    },
    'PKGCONFIGDIR' : {
         'STD-PATH':  '${LIBDIR}/pkgconfig',
         'FHS-PATH':  '${LIBDIR}/pkgconfig',
    },
    'SWATDIR' : {
         'STD-PATH':  '${DATADIR}/swat',
         'FHS-PATH':  '${DATADIR}/samba/swat',
    },
    'CODEPAGEDIR' : {
         'STD-PATH':  '${DATADIR}/codepages',
         'FHS-PATH':  '${DATADIR}/samba/codepages',
    },
    'PRIVATELIBDIR' : {
         'STD-PATH':  '${LIBDIR}/private',
         'FHS-PATH':  '${LIBDIR}/samba',
         'OPTION':    '--with-privatelibdir',
         'HELPTEXT':  'Which directory to use for private Samba libraries',
         'OVERWRITE': True,
    },
    'MODULESDIR' : {
         'STD-PATH':  '${LIBDIR}',
         'FHS-PATH':  '${LIBDIR}/samba',
         'OPTION':    '--with-modulesdir',
         'HELPTEXT':  'Which directory to use for Samba modules',
         'OVERWRITE': True,
    },
    'PAMMODULESDIR' : {
         'STD-PATH':  '${LIBDIR}/security',
         'FHS-PATH':  '${LIBDIR}/security',
         'OPTION':    '--with-pammodulesdir',
         'HELPTEXT':  'Which directory to use for PAM modules',
    },
    'CONFIGDIR' : {
         'STD-PATH':  '${SYSCONFDIR}',
         'FHS-PATH':  '${SYSCONFDIR}/samba',
         'OPTION':    '--with-configdir',
         'HELPTEXT':  'Where to put configuration files',
    },
    'PRIVATE_DIR' : {
         'STD-PATH':  '${PREFIX}/private',
         'FHS-PATH':  '${LOCALSTATEDIR}/lib/samba/private',
         'OPTION':    '--with-privatedir',
         'HELPTEXT':  'Where to put sam.ldb and other private files',
    },
    'LOCKDIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/lock',
         'FHS-PATH':  '${LOCALSTATEDIR}/lock/samba',
         'OPTION':    '--with-lockdir',
         'HELPTEXT':  'Where to put short term disposable state files',
    },
    'PIDDIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/run',
         'FHS-PATH':  '${LOCALSTATEDIR}/run/samba',
         'OPTION':    '--with-piddir',
         'HELPTEXT':  'Where to put pid files',
    },
    'STATEDIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/locks',
         'FHS-PATH':  '${LOCALSTATEDIR}/lib/samba',
         'OPTION':    '--with-statedir',
         'HELPTEXT':  'Where to put persistent state files',
    },
    'CACHEDIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/cache',
         'FHS-PATH':  '${LOCALSTATEDIR}/cache/samba',
         'OPTION':    '--with-cachedir',
         'HELPTEXT':  'Where to put temporary cache files',
    },
    'LOGFILEBASE' : {
         'STD-PATH':  '${LOCALSTATEDIR}',
         'FHS-PATH':  '${LOCALSTATEDIR}/log/samba',
         'OPTION':    '--with-logfilebase',
         'HELPTEXT':  'Where to put log files',
    },
    'SOCKET_DIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/run',
         'FHS-PATH':  '${LOCALSTATEDIR}/run/samba',
         'OPTION':    '--with-sockets-dir',
         'HELPTEXT':  'socket directory',
    },
    'PRIVILEGED_SOCKET_DIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/lib',
         'FHS-PATH':  '${LOCALSTATEDIR}/lib/samba',
         'OPTION':    '--with-privileged-socket-dir',
         'HELPTEXT':  'privileged socket directory',
    },
    'WINBINDD_SOCKET_DIR' : {
         'STD-PATH':  '${SOCKET_DIR}/winbindd',
         'FHS-PATH':  '${SOCKET_DIR}/winbindd',
         'DELAY':     True,
    },
    'WINBINDD_PRIVILEGED_SOCKET_DIR' : {
         'STD-PATH':  '${PRIVILEGED_SOCKET_DIR}/winbindd_privileged',
         'FHS-PATH':  '${PRIVILEGED_SOCKET_DIR}/winbindd_privileged',
         'DELAY':     True,
    },
    'NMBDSOCKETDIR' : {
         'STD-PATH':  '${SOCKET_DIR}/nmbd',
         'FHS-PATH':  '${SOCKET_DIR}/nmbd',
         'DELAY':     True,
    },
    'NTP_SIGND_SOCKET_DIR' : {
         'STD-PATH':  '${PRIVILEGED_SOCKET_DIR}/ntp_signd',
         'FHS-PATH':  '${PRIVILEGED_SOCKET_DIR}/ntp_signd',
         'DELAY':     True,
    },
    'NCALRPCDIR' : {
         'STD-PATH':  '${SOCKET_DIR}/ncalrpc',
         'FHS-PATH':  '${SOCKET_DIR}/ncalrpc',
         'DELAY':     True,
    },
    'CONFIGFILE' : {
         'STD-PATH':  '${CONFIGDIR}/smb.conf',
         'FHS-PATH':  '${CONFIGDIR}/smb.conf',
         'DELAY':     True,
    },
    'LMHOSTSFILE' : {
         'STD-PATH':  '${CONFIGDIR}/lmhosts',
         'FHS-PATH':  '${CONFIGDIR}/lmhosts',
         'DELAY':     True,
    },
    'SMB_PASSWD_FILE' : {
         'STD-PATH':  '${PRIVATE_DIR}/smbpasswd',
         'FHS-PATH':  '${PRIVATE_DIR}/smbpasswd',
         'DELAY':     True,
    },
}

def set_options(opt):
    opt.parser.formatter = SambaIndentedHelpFormatter()
    opt.parser.formatter.width=Utils.get_term_cols()

    for k in ('--with-privatelibdir', '--with-modulesdir'):
        option = opt.parser.get_option(k)
        if option:
            opt.parser.remove_option(k)
    del opt.parser.defaults['PRIVATELIBDIR']
    del opt.parser.defaults['MODULESDIR']

    # get all the basic GNU options from the gnu_dirs tool

    opt_group=opt.add_option_group('Samba-specific directory layout','')

    fhs_help  = "Use FHS-compliant paths (default no)\n"
    fhs_help += "You should consider using this together with:\n"
    fhs_help += "--prefix=/usr --sysconfdir=/etc --localstatedir=/var"
    opt_group.add_option('--enable-fhs', help=fhs_help,
                   action="store_true", dest='ENABLE_FHS', default=False)

    for varname in dynconfig.keys():
        if 'OPTION' not in dynconfig[varname]:
            continue
        opt = dynconfig[varname]['OPTION']
        if 'HELPTEXT' in dynconfig[varname]:
            txt = dynconfig[varname]['HELPTEXT']
        else:
            txt = "dynconfig path %s" % (varname)
        def_std = dynconfig[varname]['STD-PATH']
        def_fhs = dynconfig[varname]['FHS-PATH']

        help = "%s\n[STD-Default: %s]\n[FHS-Default: %s]" % (txt, def_std, def_fhs)
        opt_group.add_option(opt, help=help, dest=varname, action="store")

def configure(conf):
    # get all the basic GNU options from the gnu_dirs tool

    if Options.options.ENABLE_FHS:
        flavor = 'FHS-PATH'
    else:
        flavor = 'STD-PATH'
        if conf.env.PREFIX == '/usr' or conf.env.PREFIX == '/usr/local':
           Logs.error("Don't install directly under /usr or /usr/local without using the FHS option (--enable-fhs)")
           raise Utils.WafError("ERROR: invalid --prefix=%s value" % (conf.env.PREFIX))

    explicit_set ={}

    dyn_vars = {}
    for varname in dynconfig.keys():
        dyn_vars[varname] = dynconfig[varname][flavor]
        if 'OVERWRITE' in dynconfig[varname] and dynconfig[varname]['OVERWRITE']:
            # we may overwrite this option
            continue
        conf.ASSERT(varname not in conf.env, "Variable %s already defined" % varname)

    # the explicit block
    for varname in dynconfig.keys():
        if 'OPTION' not in dynconfig[varname]:
            continue
        value = getattr(Options.options, varname, None)
        if value is None:
           continue
        conf.ASSERT(value != '', "Empty dynconfig value for %s" % varname)
        conf.env[varname] = value
        # mark it as explicit from the command line
        explicit_set[varname] = value

    # defaults stage 1 after the explicit block
    for varname in dynconfig.keys():
        if 'DELAY' in dynconfig[varname] and dynconfig[varname]['DELAY']:
            # this option referrs to other options,
            # so it needs to wait for stage 2.
            continue
        value = EXPAND_VARIABLES(conf, dyn_vars[varname])
        conf.ASSERT(value != '', "Empty dynconfig value for %s" % varname)
        if varname not in explicit_set:

=== source3/wscript ===
#! /usr/bin/env python

srcdir=".."

import sys, os
from optparse import SUPPRESS_HELP
sys.path.insert(0, srcdir+"/buildtools/wafsamba")
sys.path.insert(0, "source3")
import wafsamba, Options, Logs, Utils, Scripting
import build.charset
import samba_utils, samba_version
import samba3

Options.default_prefix = '/usr/local/samba'

def set_options(opt):

    opt.add_option('--with-static-modules',
                   help=("Comma-separated list of names of modules to statically link in"),
                   action="store", dest='static_modules', default=None)
    opt.add_option('--with-shared-modules',
                   help=("Comma-separated list of names of modules to build shared"),
                   action="store", dest='shared_modules', default=None)

    opt.SAMBA3_ADD_OPTION('winbind')
    opt.SAMBA3_ADD_OPTION('swat')
    opt.SAMBA3_ADD_OPTION('ads', default=None) # None means autodetection
    opt.SAMBA3_ADD_OPTION('ldap')
    opt.SAMBA3_ADD_OPTION('cups', with_name="enable", without_name="disable")
    opt.SAMBA3_ADD_OPTION('iprint', with_name="enable", without_name="disable")
    opt.SAMBA3_ADD_OPTION('pam')
    opt.SAMBA3_ADD_OPTION('pam_smbpass')
    opt.SAMBA3_ADD_OPTION('quotas')
    opt.SAMBA3_ADD_OPTION('sendfile-support')
    opt.SAMBA3_ADD_OPTION('utmp')
    opt.SAMBA3_ADD_OPTION('pthreadpool', with_name="enable", without_name="disable", default=True)
    opt.SAMBA3_ADD_OPTION('avahi', with_name="enable", without_name="disable")
    opt.SAMBA3_ADD_OPTION('iconv')
    opt.SAMBA3_ADD_OPTION('acl-support')
    opt.SAMBA3_ADD_OPTION('dnsupdate')
    opt.SAMBA3_ADD_OPTION('syslog')
    opt.SAMBA3_ADD_OPTION('automount')
    opt.SAMBA3_ADD_OPTION('aio-support')
    opt.SAMBA3_ADD_OPTION('dmapi', default=False, help="build with DMAPI support")
    opt.SAMBA3_ADD_OPTION('profiling-data', default=False)

    opt.SAMBA3_ADD_OPTION('cluster-support', default=None)

    opt.add_option('--with-ctdb-dir',
                   help=("Directory under which ctdb is installed"),
                   action="store", dest='ctdb_dir', default=None)
    opt.add_option('--enable-old-ctdb',
                  help=("enable building against (too) old version of ctdb (default=false)"),
                  action="store_true", dest='enable_old_ctdb', default=False)



def configure(conf):
    from samba_utils import TO_LIST

    default_static_modules = []
    default_shared_modules = []

    if Options.options.developer:
        conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')
        conf.env.developer = True

    if Options.options.with_swat:
        conf.env['build_swat'] = True

    if sys.platform != 'openbsd5':
        conf.ADD_LDFLAGS("-Wl,--export-dynamic", testflags=True)

    conf.CHECK_HEADERS('execinfo.h libexc.h libunwind.h netdb.h')
    conf.CHECK_HEADERS('linux/falloc.h')

    conf.CHECK_FUNCS('getcwd fchown chmod fchmod mknod')
    conf.CHECK_FUNCS('strtol strchr strupr chflags')
    conf.CHECK_FUNCS('getrlimit fsync fdatasync setpgid')
    conf.CHECK_FUNCS('setsid glob strpbrk crypt16 getauthuid')
    conf.CHECK_FUNCS('sigprocmask sigblock sigaction sigset innetgr')
    conf.CHECK_FUNCS('initgroups select poll rdchk getgrnam getgrent pathconf')
    conf.CHECK_FUNCS('setpriv setgidx setuidx setgroups syscall sysconf')
    conf.CHECK_FUNCS('atexit grantpt posix_openpt fallocate posix_fallocate')
    conf.CHECK_FUNCS('fseeko setluid')
    conf.CHECK_FUNCS('getpwnam', headers='sys/types.h pwd.h')
    conf.CHECK_FUNCS('fdopendir')
    conf.CHECK_FUNCS('getpwent_r setenv strcasecmp fcvt fcvtl')
    conf.CHECK_FUNCS('syslog vsyslog timegm setlocale')
    conf.CHECK_FUNCS_IN('nanosleep', 'rt')
    conf.CHECK_FUNCS('lutimes futimes utimensat futimens')
    conf.CHECK_FUNCS('mlock munlock mlockall munlockall')
    conf.CHECK_FUNCS('memalign posix_memalign hstrerror')
    conf.CHECK_FUNCS('shmget')
    conf.CHECK_FUNCS_IN('shm_open', 'rt', checklibc=True)
    conf.CHECK_FUNCS('gettext dgettext bindtextdomain textdomain bind_textdomain_codeset')
    #FIXME: for some reason this one still fails
    conf.CHECK_FUNCS_IN('yp_get_default_domain', 'nsl')
    conf.CHECK_FUNCS_IN('dn_expand _dn_expand __dn_expand', 'resolv')
    conf.CHECK_FUNCS_IN('dn_expand', 'inet')
    conf.CHECK_DECLS('fdatasync', reverse=True)
    conf.CHECK_DECLS('readahead', reverse=True, headers='fcntl.h')

    if conf.CONFIG_SET('HAVE_LONG_LONG'):
        conf.DEFINE('HAVE_LONGLONG', 1)

    if conf.CHECK_CODE('''
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif
long ret = splice(0,0,1,0,400,SPLICE_F_MOVE);
''',
        'HAVE_LINUX_SPLICE',
        headers='fcntl.h'):
        conf.CHECK_DECLS('splice', reverse=True, headers='fcntl.h')

    # Check for inotify support
    conf.CHECK_HEADERS('sys/inotify.h')
    if "HAVE_SYS_INOTIFY_H" in conf.env:
        conf.DEFINE('HAVE_INOTIFY', 1)

    # Check for kernel change notify support
    conf.CHECK_CODE('''
#ifndef F_NOTIFY
#define F_NOTIFY 1026
#endif
main() {
        exit(fcntl(open("/tmp", O_RDONLY), F_NOTIFY, 0) == -1 ?  1 : 0);
}''', 'HAVE_KERNEL_CHANGE_NOTIFY', addmain=False, execute=True,
        headers='fcntl.h signal.h',
        msg="Checking for kernel change notify support")

    # Check for Linux kernel oplocks
    conf.CHECK_CODE('''
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#ifndef F_NOTIFY
#define F_NOTIFY 1026
#endif
main() {
        exit(fcntl(open("/tmp", O_RDONLY), F_NOTIFY, 0) == -1 ?  1 : 0);
}''', 'HAVE_KERNEL_OPLOCKS_LINUX', addmain=False, execute=True,
        msg="Checking for Linux kernel oplocks")

    # Check for IRIX kernel oplock types
    conf.CHECK_CODE('oplock_stat_t t; t.os_state = OP_REVOKE; t.os_dev = 1; t.os_ino = 1;',
                    'HAVE_KERNEL_OPLOCKS_IRIX', headers='fcntl.h',
                    msg="Checking for IRIX kernel oplock types")

    # Check for kernel share modes
    conf.CHECK_CODE('''
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/file.h>
#ifndef LOCK_MAND
#define LOCK_MAND        32
#define LOCK_READ        64
#endif
main() {
        exit(flock(open("/dev/null", O_RDWR), LOCK_MAND|LOCK_READ) != 0);
}''', 'HAVE_KERNEL_SHARE_MODES', addmain=False, execute=True,
        msg="Checking for kernel share modes")

    # check for DMAPI libs
    Logs.info("Checking for DMAPI library existence")
    conf.env['dmapi_lib'] = ''
    samba_dmapi_lib = ''
    if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'dm'):
        samba_dmapi_lib = 'dm'
    else:
        if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'jfsdm'):
            samba_dmapi_lib = 'jfsdm'
        else:
            if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'dmapi'):
                samba_dmapi_lib = 'dmapi'
            else:
                if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'xdsm'):
                    samba_dmapi_lib = 'xdsm'
    # only bother to test headers and compilation when a candidate
    # library has been found
    if Options.options.with_dmapi == True and samba_dmapi_lib == '':
        conf.fatal('DMAPI support requested, but no suitable DMAPI library found')
    else:
        conf.CHECK_HEADERS('sys/dmi.h xfs/dmapi.h sys/jfsdmapi.h sys/dmapi.h dmapi.h')
        conf.CHECK_CODE('''
#include <time.h>      /* needed by Tru64 */
#include <sys/types.h> /* needed by AIX */
#ifdef HAVE_XFS_DMAPI_H
#include <xfs/dmapi.h>
#elif defined(HAVE_SYS_DMI_H)
#include <sys/dmi.h>
#elif defined(HAVE_SYS_JFSDMAPI_H)
#include <sys/jfsdmapi.h>
#elif defined(HAVE_SYS_DMAPI_H)
#include <sys/dmapi.h>
#elif defined(HAVE_DMAPI_H)
#include <dmapi.h>
#endif

/* This link test is designed to fail on IRI 6.4, but should
 * succeed on Linux, IRIX 6.5 and AIX.
 */
int main(int argc, char **argv)
{
	char * version;
	dm_eventset_t events;
	/* This doesn't take an argument on IRIX 6.4. */
	dm_init_service(&version);
	/* IRIX 6.4 expects events to be a pointer. */
	DMEV_ISSET(DM_EVENT_READ, events);

	return 0;
}
''',
        'USE_DMAPI',
        addmain=False,
        execute=False,
        lib=samba_dmapi_lib,
        msg='Checking whether DMAPI lib '+samba_dmapi_lib+' can be used')

        if conf.CONFIG_SET('USE_DMAPI'):
            conf.env['dmapi_lib'] = samba_dmapi_lib
        else:
            if Options.options.with_dmapi == True:
                conf.fatal('DMAPI support requested but not found');

    # Check for various members of the stat structure
    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_blocks', define='HAVE_STAT_ST_BLOCKS',
                                headers='sys/stat.h')
    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_blksize', define='HAVE_STAT_ST_BLKSIZE',
                                headers='sys/stat.h')
    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_flags', define='HAVE_STAT_ST_FLAGS',
                                headers='sys/types.h sys/stat.h unistd.h')

    if "HAVE_BLKCNT_T" in conf.env:
	conf.CHECK_CODE('''
	return sizeof(blkcnt_t) == 4 ? 0 : 1''',
		'SIZEOF_BLKCNT_T_4', execute=True,
		headers='replace.h sys/types.h sys/stat.h unistd.h',
		msg="Checking whether blkcnt_t is 32 bit")

    if "HAVE_BLKCNT_T" in conf.env:
	conf.CHECK_CODE('''
	return sizeof(blkcnt_t) == 8 ? 0 : 1''',
		'SIZEOF_BLKCNT_T_8', execute=True,
		headers='replace.h sys/types.h sys/stat.h unistd.h',
		msg="Checking whether blkcnt_t is 64 bit")

    # Check for POSIX capability support
    conf.CHECK_FUNCS_IN('cap_get_proc', 'cap', headers='sys/capability.h')

    if "HAVE_SYS_CAPABILITY_H" in conf.env:
        conf.CHECK_CODE('''
        cap_t cap;
        cap_value_t vals[1];
        if (!(cap = cap_get_proc())) exit(1);
        vals[0] = CAP_CHOWN;
        cap_set_flag(cap, CAP_INHERITABLE, 1, vals, CAP_CLEAR);
        cap_set_proc(cap);''',
                        'HAVE_POSIX_CAPABILITIES', execute=True, lib="cap",
                        headers='sys/capability.h',
                        msg="Checking whether POSIX capabilities are available")

    # Check for int16, uint16, int32 and uint32 in rpc/types.h included from
    # rpc/rpc.h. This is *really* broken but some systems (DEC OSF1) do this.
    # -- JRA.
    if conf.CONFIG_SET("HAVE_RPC_RPC_H"):
        conf.CHECK_TYPE('int16', headers='rpc/rpc.h',
                        define='HAVE_INT16_FROM_RPC_RPC_H',
                        msg="Checking for int16 typedef included by rpc/rpc.h")
        conf.CHECK_CODE('uint16 testvar;', 'HAVE_INT16_FROM_RPC_RPC_H',
                        headers='sys/types.h rpc/rpc.h',
                        msg="Checking for uint16 typedef included by rpc/rpc.h")
        conf.CHECK_CODE('int32 testvar;', 'HAVE_INT16_FROM_RPC_RPC_H',
                        headers='sys/types.h rpc/rpc.h',
                        msg="Checking for int32 typedef included by rpc/rpc.h")
        conf.CHECK_CODE('uint32 testvar;', 'HAVE_INT16_FROM_RPC_RPC_H',
                        headers='sys/types.h rpc/rpc.h',
                        msg="Checking for uint32 typedef included by rpc/rpc.h")
    conf.CHECK_CODE('int i;', 'BROKEN_NISPLUS_INCLUDE_FILES',
                    headers='sys/types.h sys/acl.h rpcsvc/nis.h',
                    msg="Checking for broken nisplus include files")

    # Check if the compiler will optimize out functions
    conf.CHECK_CODE('''
if (0) {
    this_function_does_not_exist();
} else {
    return 1;
}''', 'HAVE_COMPILER_WILL_OPTIMIZE_OUT_FNS',
        msg="Checking if the compiler will optimize out functions")

    # Check if the compiler supports the LL suffix on long long integers
    # AIX needs this
    conf.CHECK_CODE('long long i = 0x8000000000LL', 'COMPILER_SUPPORTS_LL',
                    headers='stdio.h',
                    msg="Checking for LL suffix on long long integers")

    conf.CHECK_FUNCS('''
_acl __acl atexit 
bindtextdomain _chdir __chdir chflags chmod _close __close _closedir
__closedir crypt16 devnm dgettext dirfd
DNSServiceRegister _dup __dup _dup2 __dup2 endmntent execl
_facl __facl _fchdir
__fchdir fchmod fchown _fcntl __fcntl fcvt fcvtl fdatasync
_fork __fork fseeko

=== lib/ldb/wscript ===
#!/usr/bin/env python

APPNAME = 'ldb'
VERSION = '1.1.15'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options

samba_dist.DIST_DIRS('''lib/ldb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tdb:lib/tdb lib/tdb:lib/tdb lib/tevent:lib/tevent lib/popt:lib/popt
                        buildtools:buildtools''')


def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('ldb', noextension='ldb')
    opt.RECURSE('lib/tdb')
    opt.RECURSE('lib/tevent')
    opt.RECURSE('lib/replace')
    opt.tool_options('python') # options for disabling pyc or pyo compilation

def configure(conf):
    conf.RECURSE('lib/tdb')
    conf.RECURSE('lib/tevent')
    conf.RECURSE('lib/popt')
    conf.RECURSE('lib/replace')
    conf.find_program('python', var='PYTHON')
    conf.find_program('xsltproc', var='XSLTPROC')
    conf.check_tool('python')
    conf.check_python_version((2,4,2))
    conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=True)

    # where does the default LIBDIR end up? in conf.env somewhere?
    #
    conf.CONFIG_PATH('LDB_MODULESDIR', conf.SUBST_ENV_VAR('MODULESDIR') + '/ldb')

    conf.env.standalone_ldb = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_ldb:
        if conf.CHECK_BUNDLED_SYSTEM_PKG('ldb', minversion=VERSION,
                                     onlyif='talloc tdb tevent',
                                     implied_deps='replace talloc tdb tevent'):
            conf.define('USING_SYSTEM_LDB', 1)
        if conf.CHECK_BUNDLED_SYSTEM_PKG('pyldb-util', minversion=VERSION,
                                     onlyif='talloc tdb tevent ldb',
                                     implied_deps='replace talloc tdb tevent ldb'):
            conf.define('USING_SYSTEM_PYLDB_UTIL', 1)

    if conf.env.standalone_ldb:
        conf.CHECK_XSLTPROC_MANPAGES()

        # we need this for the ldap backend
        if conf.CHECK_FUNCS_IN('ber_flush ldap_open ldap_initialize', 'lber ldap', headers='lber.h ldap.h'):
            conf.env.ENABLE_LDAP_BACKEND = True

        # we don't want any libraries or modules to rely on runtime
        # resolution of symbols
        if sys.platform != "openbsd4" and sys.platform != "openbsd5":
            conf.ADD_LDFLAGS('-Wl,-no-undefined', testflags=True)

    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

def build(bld):
    bld.RECURSE('lib/tevent')
    bld.RECURSE('lib/popt')
    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/tdb')

    if bld.env.standalone_ldb:
        private_library = False
    else:
        private_library = True

    LDB_MAP_SRC = bld.SUBDIR('ldb_map',
                             'ldb_map.c ldb_map_inbound.c ldb_map_outbound.c')

    COMMON_SRC = bld.SUBDIR('common',
                            '''ldb_modules.c ldb_ldif.c ldb_parse.c ldb_msg.c ldb_utf8.c
                            ldb_debug.c ldb_dn.c ldb_match.c ldb_options.c ldb_pack.c
                            ldb_attributes.c attrib_handlers.c ldb_controls.c qsort.c''')

    bld.SAMBA_MODULE('ldb_ldap', 'ldb_ldap/ldb_ldap.c',
                     init_function='ldb_ldap_init',
                     module_init_name='ldb_init_module',
                     deps='talloc lber ldap ldb',
                     enabled=bld.env.ENABLE_LDAP_BACKEND,
                     internal_module=False,
                     subsystem='ldb')

    # we're not currently linking against the ldap libs, but ldb.pc.in
    # has @LDAP_LIBS@
    bld.env.LDAP_LIBS = ''

    if not 'PACKAGE_VERSION' in bld.env:
        bld.env.PACKAGE_VERSION = VERSION
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'

    if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
        bld.SAMBA_LIBRARY('pyldb-util',
                          deps='ldb',
                          source='pyldb_util.c',
                          public_headers='pyldb.h',
                          public_headers_install=not private_library,
                          vnum=VERSION,
                          private_library=private_library,
                          pc_files='pyldb-util.pc',
                          pyembed=True,
                          abi_directory='ABI',
                          abi_match='pyldb_*')

    if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
        if Options.is_install:
            modules_dir = bld.EXPAND_VARIABLES('${LDB_MODULESDIR}')
        else:
            # when we run from the source directory, we want to use
            # the current modules, not the installed ones
            modules_dir = os.path.join(os.getcwd(), 'bin/modules/ldb')

        abi_match = '!ldb_*module_ops !ldb_*backend_ops ldb_*'

        bld.SAMBA_LIBRARY('ldb',
                          COMMON_SRC + ' ' + LDB_MAP_SRC,
                          deps='tevent LIBLDB_MAIN',
                          includes='include',
                          public_headers='include/ldb.h include/ldb_errors.h '\
                          'include/ldb_module.h include/ldb_handlers.h',
                          public_headers_install=not private_library,
                          pc_files='ldb.pc',
                          vnum=VERSION,
                          private_library=private_library,
                          manpages='man/ldb.3',
                          abi_directory='ABI',
                          abi_match = abi_match)

        # generate a include/ldb_version.h
        t = bld.SAMBA_GENERATOR('ldb_version.h',
                                rule='echo "#define LDB_VERSION \\"${LDB_VERSION}\\"" > ${TGT}',
                                target='include/ldb_version.h',
                                public_headers='include/ldb_version.h',
                                public_headers_install=not private_library)
        t.env.LDB_VERSION = VERSION
        bld.add_manual_dependency(bld.path.find_or_declare('include/ldb_version.h'), VERSION)



        bld.SAMBA_PYTHON('pyldb', 'pyldb.c',
                         deps='ldb pyldb-util',
                         realname='ldb.so',
                         cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

        bld.SAMBA_MODULE('ldb_paged_results',
                         'modules/paged_results.c',
                         init_function='ldb_paged_results_init',
                         module_init_name='ldb_init_module',
                         internal_module=False,
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_asq',
                         'modules/asq.c',
                         init_function='ldb_asq_init',
                         module_init_name='ldb_init_module',
                         internal_module=False,
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_server_sort',
                         'modules/sort.c',
                         init_function='ldb_server_sort_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_paged_searches',
                         'modules/paged_searches.c',
                         init_function='ldb_paged_searches_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_rdn_name',
                         'modules/rdn_name.c',
                         init_function='ldb_rdn_name_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_sample',
                         'tests/sample_module.c',
                         init_function='ldb_sample_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_skel',
                         'modules/skel.c',
                         init_function='ldb_skel_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_sqlite3',
                         'sqlite3/ldb_sqlite3.c',
                         init_function='ldb_sqlite3_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         enabled=False,
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_tdb',
                         bld.SUBDIR('ldb_tdb',
                                    '''ldb_tdb.c ldb_search.c ldb_index.c
                                    ldb_cache.c ldb_tdb_wrap.c'''),
                         init_function='ldb_tdb_init',
                         module_init_name='ldb_init_module',
                         internal_module=False,
                         deps='tdb ldb',
                         subsystem='ldb')

        # have a separate subsystem for common/ldb.c, so it can rebuild
        # for install with a different -DLDB_MODULESDIR=
        bld.SAMBA_SUBSYSTEM('LIBLDB_MAIN',
                            'common/ldb.c',
                            deps='tevent tdb',
                            includes='include',
                            cflags=['-DLDB_MODULESDIR=\"%s\"' % modules_dir])

        LDB_TOOLS='ldbadd ldbsearch ldbdel ldbmodify ldbedit ldbrename'
        for t in LDB_TOOLS.split():
            bld.SAMBA_BINARY(t, 'tools/%s.c' % t, deps='ldb-cmdline ldb',
                             manpages='man/%s.1' % t)

        # ldbtest doesn't get installed
        bld.SAMBA_BINARY('ldbtest', 'tools/ldbtest.c', deps='ldb-cmdline ldb',
                         install=False)

        # ldbdump doesn't get installed
        bld.SAMBA_BINARY('ldbdump', 'tools/ldbdump.c', deps='ldb-cmdline ldb',
                         install=False)

    bld.SAMBA_LIBRARY('ldb-cmdline',
                      source='tools/ldbutil.c tools/cmdline.c',
                      deps='ldb dl popt',
                      private_library=True)


def test(ctx):
    '''run ldb testsuite'''
    import Utils, samba_utils, shutil
    test_prefix = "%s/st" % (Utils.g_module.blddir)
    shutil.rmtree(test_prefix, ignore_errors=True)
    os.makedirs(test_prefix)
    os.environ['TEST_DATA_PREFIX'] = test_prefix
    cmd = 'tests/test-tdb.sh %s' % Utils.g_module.blddir
    ret = samba_utils.RUN_COMMAND(cmd)
    print("testsuite returned %d" % ret)
    # FIXME: Run python testsuite
    sys.exit(ret)

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)

=== lib/ntdb/wscript ===
#!/usr/bin/env python

APPNAME = 'ntdb'
VERSION = '0.9'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options, Logs, glob

samba_dist.DIST_DIRS('lib/ntdb:. lib/replace:lib/replace lib/ccan:lib/ccan buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('replace,ccan')
    opt.PRIVATE_EXTENSION_DEFAULT('ntdb', noextension='ntdb')
    opt.RECURSE('lib/replace')
    opt.add_option('--valgrind',
                   help=("use valgrind on tests programs"),
                   action="store_true", dest='VALGRIND', default=False)
    opt.add_option('--valgrind-log',
                   help=("where to put the valgrind log"),
                   action="store", dest='VALGRINDLOG', default=None)

    if opt.IN_LAUNCH_DIR():
        opt.add_option('--disable-python',
                       help=("disable the pyntdb module"),
                       action="store_true", dest='disable_python', default=False)

def configure(conf):
    conf.RECURSE('lib/replace')
    conf.RECURSE('lib/ccan')

    conf.env.NTDB_TEST_RUN_SRC=['test/run-001-encode.c',
                                'test/run-001-fls.c',
                                'test/run-01-new_database.c',
                                'test/run-02-expand.c',
                                'test/run-03-coalesce.c',
                                'test/run-04-basichash.c',
                                'test/run-05-readonly-open.c',
                                'test/run-10-simple-store.c',
                                'test/run-11-simple-fetch.c',
                                'test/run-12-check.c',
                                'test/run-15-append.c',
                                'test/run-25-hashoverload.c',
                                'test/run-30-exhaust-before-expand.c',
                                'test/run-35-convert.c',
                                'test/run-50-multiple-freelists.c',
                                'test/run-56-open-during-transaction.c',
                                'test/run-57-die-during-transaction.c',
                                'test/run-64-bit-tdb.c',
                                'test/run-90-get-set-attributes.c',
                                'test/run-capabilities.c',
                                'test/run-expand-in-transaction.c',
                                'test/run-features.c',
                                'test/run-lockall.c',
                                'test/run-remap-in-read_traverse.c',
                                'test/run-seed.c',
                                'test/run-tdb_errorstr.c',
                                'test/run-tdb_foreach.c',
                                'test/run-traverse.c']
    conf.env.NTDB_TEST_API_SRC=['test/api-12-store.c',
                                'test/api-13-delete.c',
                                'test/api-14-exists.c',
                                'test/api-16-wipe_all.c',
                                'test/api-20-alloc-attr.c',
                                'test/api-21-parse_record.c',
                                'test/api-55-transaction.c',
                                'test/api-80-tdb_fd.c',
                                'test/api-81-seqnum.c',
                                'test/api-82-lockattr.c',
                                'test/api-83-openhook.c',
                                'test/api-91-get-stats.c',
                                'test/api-92-get-set-readonly.c',
                                'test/api-93-repack.c',
                                'test/api-94-expand-during-parse.c',
                                'test/api-95-read-only-during-parse.c',
                                'test/api-add-remove-flags.c',
                                'test/api-check-callback.c',
                                'test/api-firstkey-nextkey.c',
                                'test/api-fork-test.c',
                                'test/api-locktimeout.c',
                                'test/api-missing-entries.c',
                                'test/api-open-multiple-times.c',
                                'test/api-record-expand.c',
                                'test/api-simple-delete.c',
                                'test/api-summary.c']
    conf.env.NTDB_TEST_API_HELPER_SRC=['test/helpapi-external-agent.c']
    conf.env.NTDB_TEST_RUN_HELPER_SRC=['test/helprun-external-agent.c',
                                       'test/helprun-layout.c']
    conf.env.NTDB_TEST_HELPER_SRC=['test/external-agent.c',
                                   'test/failtest_helper.c',
                                   'test/lock-tracking.c',
                                   'test/logging.c',
                                   'test/tap-interface.c']

    conf.env.standalone_ntdb = conf.IN_LAUNCH_DIR()
    conf.env.disable_python = getattr(Options.options, 'disable_python', False)

    if not conf.env.standalone_ntdb:
        if conf.CHECK_BUNDLED_SYSTEM('ntdb', minversion=VERSION,
                                         implied_deps='replace'):
            conf.define('USING_SYSTEM_NTDB', 1)
            if conf.CHECK_BUNDLED_SYSTEM_PYTHON('pyntdb', 'ntdb', minversion=VERSION):
                conf.define('USING_SYSTEM_PYNTDB', 1)

    if not conf.env.disable_python:
        # also disable if we don't have the python libs installed
        conf.find_program('python', var='PYTHON')
        conf.check_tool('python')
        conf.check_python_version((2,4,2))
        conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=False)
        if not conf.env.HAVE_PYTHON_H:
            Logs.warn('Disabling pyntdb as python devel libs not found')
            conf.env.disable_python = True

    # This make #include <ccan/...> work.
    conf.ADD_EXTRA_INCLUDES('''#lib''')

    conf.SAMBA_CONFIG_H()

def build(bld):
    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/ccan')

    if bld.env.standalone_ntdb:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        private_library = False
    else:
        private_library = True

    SRC = '''check.c free.c hash.c io.c lock.c open.c
                 summary.c ntdb.c transaction.c traverse.c'''

    if not bld.CONFIG_SET('USING_SYSTEM_NTDB'):
        NTDB_CCAN='ccan-likely ccan-ilog ccan-hash ccan-tally'
        bld.SAMBA_LIBRARY('ntdb',
                          SRC,
                          deps='replace ' + NTDB_CCAN ,
                          includes='.',
                          abi_directory='ABI',
                          abi_match='ntdb_*',
                          hide_symbols=True,
                          vnum=VERSION,
                          public_headers='ntdb.h',
                          public_headers_install=not private_library,
                          pc_files='ntdb.pc',
                          private_library=private_library)

        bld.SAMBA_BINARY('ntdbtorture',
                         'tools/ntdbtorture.c',
                         deps='ntdb ccan-err',
                         install=False)

        bld.SAMBA_BINARY('ntdbtool',
                         'tools/ntdbtool.c',
                         deps='ntdb')

        bld.SAMBA_BINARY('ntdbdump',
                         'tools/ntdbdump.c',
                         deps='ntdb')

        bld.SAMBA_BINARY('ntdbrestore',
                         'tools/ntdbrestore.c',
                         deps='ntdb')

        bld.SAMBA_BINARY('ntdbbackup',
                         'tools/ntdbbackup.c',
                         deps='ntdb')

        if bld.env.DEVELOPER_MODE:
            # FIXME: We need CCAN for some API tests, but waf thinks it's
            # already available via ntdb.  It is, but not publicly.
            # Workaround is to build a private, non-hiding version.
            bld.SAMBA_SUBSYSTEM('ntdb-testing',
                                SRC,
                                deps='replace ' + NTDB_CCAN,
                                includes='.')

            bld.SAMBA_SUBSYSTEM('ntdb-test-helpers',
                                bld.env.NTDB_TEST_HELPER_SRC,
                                deps='replace')
            bld.SAMBA_SUBSYSTEM('ntdb-run-helpers',
                                bld.env.NTDB_TEST_RUN_HELPER_SRC,
                                deps='replace')
            bld.SAMBA_SUBSYSTEM('ntdb-api-helpers',
                                bld.env.NTDB_TEST_API_HELPER_SRC,
                                deps='replace')

            for f in bld.env.NTDB_TEST_RUN_SRC:
                base = os.path.splitext(os.path.basename(f))[0]
                bld.SAMBA_BINARY('ntdb-' + base, f,
                                 deps=NTDB_CCAN + ' ccan-failtest ntdb-test-helpers ntdb-run-helpers',
                                 install=False)

            for f in bld.env.NTDB_TEST_API_SRC:
                base = os.path.splitext(os.path.basename(f))[0]
                bld.SAMBA_BINARY('ntdb-' + base, f,
                                 deps='ntdb-test-helpers ntdb-api-helpers ntdb-testing',
                                 install=False)

        if not bld.CONFIG_SET('USING_SYSTEM_PYNTDB'):
            bld.SAMBA_PYTHON('pyntdb',
                             source='pyntdb.c',
                             deps='ntdb',
                             enabled=not bld.env.disable_python,
                             realname='ntdb.so',
                             cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

def testonly(ctx):
    '''run ntdb testsuite'''
    import Utils, samba_utils, shutil
    ecode = 0;

    env = samba_utils.LOAD_ENVIRONMENT()

    if env.standalone_ntdb:
        # FIXME: This is horrible :(
        test_prefix = "%s/st" % (Utils.g_module.blddir)
        shutil.rmtree(test_prefix, ignore_errors=True)
        os.makedirs(test_prefix)

        # Create scratch directory for tests.
        testdir = os.path.join(test_prefix, 'ntdb-tests')
        samba_utils.mkdir_p(testdir)
        # Symlink back to source dir so it can find tests in test/
        link = os.path.join(testdir, 'test')
        if not os.path.exists(link):
            os.symlink(os.path.abspath(os.path.join(env.cwd, 'test')), link)

        if env.options['VALGRIND']:
            os.environ['VALGRIND'] = 'valgrind -q --num-callers=30 --error-exitcode=11'
        if env.options['VALGRINDLOG']:
            os.environ['VALGRIND'] += ' --log-file=%s' % Options.options.VALGRINDLOG

        for f in env.NTDB_TEST_RUN_SRC + env.NTDB_TEST_API_SRC:
            name = "ntdb-" + os.path.splitext(os.path.basename(f))[0]
            cmd = "cd " + testdir + " && $VALGRIND " + os.path.abspath(os.path.join(Utils.g_module.blddir, name)) + " > test-output 2>&1"
            print("..." + f)
            ret = samba_utils.RUN_COMMAND(cmd)
            if ret != 0:
                print("%s (%s) failed:" % (name, f))
                samba_utils.RUN_COMMAND("cat " + os.path.join(testdir, 'test-output'))
                ecode = ret;
                break;

    sys.exit(ecode)

# WAF doesn't build the unit tests for this, maybe because they don't link with ntdb?
# This forces it
def test(ctx):
    import Scripting
    Scripting.commands.append('build')
    Scripting.commands.append('testonly')

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

blddir = 'bin'

import sys, os, Utils

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist
import Options, os, preproc

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@wafsamba.runonce
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.env.standalone_replace = conf.IN_LAUNCH_DIR()

    conf.DEFINE('HAVE_LIBREPLACE', 1)
    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    # on Tru64 certain features are only available with _OSF_SOURCE set to 1
    # and _XOPEN_SOURCE set to 600
    if conf.env['SYSTEM_UNAME_SYSNAME'] == 'OSF1':
        conf.DEFINE('_OSF_SOURCE', 1, add_to_cflags=True)
        conf.DEFINE('_XOPEN_SOURCE', 600, add_to_cflags=True)

    # SCM_RIGHTS is only avail if _XOPEN_SOURCE iѕ defined on IRIX
    if conf.env['SYSTEM_UNAME_SYSNAME'] == 'IRIX':
        conf.DEFINE('_XOPEN_SOURCE', 600, add_to_cflags=True)
        conf.DEFINE('_BSD_TYPES', 1, add_to_cflags=True)

    # Try to find the right extra flags for C99 initialisers
    for f in ["", "-AC99", "-qlanglvl=extc99", "-qlanglvl=stdc99", "-c99"]:
        if conf.CHECK_CFLAGS([f], '''
struct foo {int x;char y;};
struct foo bar = { .y = 'X', .x = 1 };
'''):
            if f != "":
                conf.ADD_CFLAGS(f)
            break

    # Try to find the right extra flags for -Werror behaviour
    for f in ["-Werror",       # GCC
	      "-errwarn=%all", # Sun Studio
	      "-qhalt=w",     # IBM xlc
	      "-w2",           # Tru64
	      ]:
        if conf.CHECK_CFLAGS([f], '''
'''):
            if not 'WERROR_CFLAGS' in conf.env:
                conf.env['WERROR_CFLAGS'] = []
            conf.env['WERROR_CFLAGS'].extend([f])
            break

    conf.CHECK_HEADERS('linux/types.h crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('libaio.h locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h attr/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h sys/fs/vx/quota.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h sys/file.h')
    conf.CHECK_HEADERS('sys/ucontext.h sys/wait.h sys/stat.h malloc.h grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('libintl.h errno.h')
    conf.CHECK_HEADERS('gcrypt.h getopt.h iconv.h')
    conf.CHECK_HEADERS('sys/inotify.h memory.h nss.h sasl/sasl.h')
    conf.CHECK_HEADERS('security/pam_appl.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('aio.h sys/unistd.h rpc/rpc.h rpc/nettype.h alloca.h float.h')

    conf.CHECK_HEADERS('rpcsvc/nis.h rpcsvc/ypclnt.h sys/prctl.h sys/sysctl.h')
    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h')

    conf.CHECK_CODE('', headers='rpc/rpc.h rpcsvc/yp_prot.h', define='HAVE_RPCSVC_YP_PROT_H')

    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h valgrind/memcheck.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h malloc.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')

    conf.CHECK_CODE('''
                    #include <unistd.h>
                    #ifdef HAVE_FCNTL_H
                    #include <fcntl.h>
                    #endif
                    int main(void) { int fd = open("/dev/null", O_DIRECT); }
                    ''',
                    define='HAVE_OPEN_O_DIRECT',
                    addmain=False,
                    msg='Checking for O_DIRECT flag to open(2)')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t comparison_fn_t')
    conf.CHECK_TYPE('_Bool', define='HAVE__Bool')
    conf.CHECK_TYPE('bool', define='HAVE_BOOL')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('uint8_t', 'unsigned char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')
    conf.CHECK_TYPE('blksize_t', 'long', headers='sys/types.h sys/stat.h unistd.h')
    conf.CHECK_TYPE('blkcnt_t', 'long', headers='sys/types.h sys/stat.h unistd.h')

    conf.CHECK_SIZEOF('bool char int "long long" long short size_t ssize_t')
    conf.CHECK_SIZEOF('int8_t uint8_t int16_t uint16_t int32_t uint32_t int64_t uint64_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')
    conf.CHECK_SIZEOF('off_t dev_t ino_t time_t')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')

    conf.CHECK_FUNCS_IN('''inet_ntoa inet_aton inet_ntop inet_pton connect gethostbyname
                           getaddrinfo getnameinfo freeaddrinfo gai_strerror socketpair''',
                        'socket nsl', checklibc=True,
                        headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);
                       int ret = getaddrinfo(NULL, NULL, NULL, &ai);
                       if (ret != 0) {
                           const char *es = gai_strerror(ret);
                       }
                       freeaddrinfo(ai);
                       {
                          int val = 1;
                          #ifdef HAVE_LINUX_IPV6_V6ONLY_26
                          #define IPV6_V6ONLY 26
                          #endif
                          ret = setsockopt(s, IPPROTO_IPV6, IPV6_V6ONLY,
                                           (const void *)&val, sizeof(val));
                       }
                       ''',
                    define='HAVE_IPV6',
                    lib='nsl socket',
                    headers='sys/socket.h netdb.h netinet/in.h')

    if conf.CONFIG_SET('HAVE_SYS_UCONTEXT_H') and conf.CONFIG_SET('HAVE_SIGNAL_H'):
        conf.CHECK_CODE('''
                       ucontext_t uc;
                       sigaddset(&uc.uc_sigmask, SIGUSR1);
                       ''',
                       'HAVE_UCONTEXT_T',
                       msg="Checking whether we have ucontext_t",
                       headers='signal.h sys/ucontext.h')

    # these may be builtins, so we need the link=False strategy
    conf.CHECK_FUNCS('strdup memmem printf memset memcpy memmove strcpy strncpy bzero', link=False)

    conf.CHECK_FUNCS('shl_load shl_unload shl_findsym')
    conf.CHECK_FUNCS('pipe strftime srandom random srand rand usleep setbuffer')
    conf.CHECK_FUNCS('lstat getpgrp utime utimes setuid seteuid setreuid setresuid setgid setegid')
    conf.CHECK_FUNCS('setregid setresgid chroot strerror vsyslog setlinebuf mktime')
    conf.CHECK_FUNCS('ftruncate chsize rename waitpid wait4')
    conf.CHECK_FUNCS('initgroups pread pwrite strndup strcasestr')
    conf.CHECK_FUNCS('strtok_r mkdtemp dup2 dprintf vdprintf isatty chown lchown')
    conf.CHECK_FUNCS('link readlink symlink realpath snprintf vsnprintf')
    conf.CHECK_FUNCS('asprintf vasprintf setenv unsetenv strnlen strtoull __strtoull')
    conf.CHECK_FUNCS('strtouq strtoll __strtoll strtoq memalign posix_memalign')

    # libbsd on some platforms provides strlcpy and strlcat
    if not conf.CHECK_FUNCS('strlcpy strlcat'):
        conf.CHECK_FUNCS_IN('strlcpy strlcat', 'bsd', headers='bsd/string.h',
                checklibc=True)
    if not conf.CHECK_FUNCS('getpeereid'):
        conf.CHECK_FUNCS_IN('getpeereid', 'bsd', headers='sys/types.h bsd/unistd.h')
    if not conf.CHECK_FUNCS_IN('setproctitle', 'bsd', headers='sys/types.h bsd/unistd.h'):
        conf.CHECK_FUNCS_IN('setproctitle', 'setproctitle', headers='setproctitle.h')

    conf.CHECK_CODE('''
                struct ucred cred;
                socklen_t cred_len;
                int ret = getsockopt(0, SOL_SOCKET, SO_PEERCRED, &cred, &cred_len);''',
                'HAVE_PEERCRED',
                msg="Checking whether we can use SO_PEERCRED to get socket credentials",
                headers='sys/types.h sys/socket.h')

    #Some OS (ie. freebsd) return EINVAL if the convertion could not be done, it's not what we expect
    #Let's detect those cases
    if conf.CONFIG_SET('HAVE_STRTOLL'):
        conf.CHECK_CODE('''
                        long long nb = strtoll("Text", NULL, 0);
                        if (errno == EINVAL) {
                            return 0;
                        } else {
                            return 1;
                        }
                        ''',
                        msg="Checking correct behavior of strtoll",
                        headers = 'errno.h',
                        execute = True,
                        define = 'HAVE_BSD_STRTOLL',

=== lib/tevent/wscript ===
#!/usr/bin/env python

APPNAME = 'tevent'
VERSION = '0.9.17'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options, Logs

samba_dist.DIST_DIRS('lib/tevent:. lib/replace:lib/replace lib/talloc:lib/talloc buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('tevent', noextension='tevent')
    opt.RECURSE('lib/replace')
    opt.RECURSE('lib/talloc')
    if opt.IN_LAUNCH_DIR():
        opt.add_option('--disable-python',
                       help=("disable the pytevent module"),
                       action="store_true", dest='disable_python', default=False)


def configure(conf):
    conf.RECURSE('lib/replace')
    conf.RECURSE('lib/talloc')

    conf.env.standalone_tevent = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_tevent:
        if conf.CHECK_BUNDLED_SYSTEM_PKG('tevent', minversion=VERSION,
                                     onlyif='talloc', implied_deps='replace talloc'):
            conf.define('USING_SYSTEM_TEVENT', 1)
            if conf.CHECK_BUNDLED_SYSTEM_PYTHON('pytevent', 'tevent', minversion=VERSION):
                conf.define('USING_SYSTEM_PYTEVENT', 1)

    if conf.CHECK_FUNCS('epoll_create', headers='sys/epoll.h'):
        conf.DEFINE('HAVE_EPOLL', 1)

    conf.env.disable_python = getattr(Options.options, 'disable_python', False)

    if not conf.env.disable_python:
        # also disable if we don't have the python libs installed
        conf.find_program('python', var='PYTHON')
        conf.check_tool('python')
        conf.check_python_version((2,4,2))
        conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=False)
        if not conf.env.HAVE_PYTHON_H:
            Logs.warn('Disabling pytevent as python devel libs not found')
            conf.env.disable_python = True

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

def build(bld):
    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/talloc')

    SRC = '''tevent.c tevent_debug.c tevent_fd.c tevent_immediate.c
             tevent_queue.c tevent_req.c tevent_select.c
             tevent_poll.c
             tevent_signal.c tevent_standard.c tevent_timed.c tevent_util.c tevent_wakeup.c'''

    if bld.CONFIG_SET('HAVE_EPOLL'):
        SRC += ' tevent_epoll.c'

    if bld.env.standalone_tevent:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        private_library = False
    else:
        private_library = True

    if not bld.CONFIG_SET('USING_SYSTEM_TEVENT'):
        bld.SAMBA_LIBRARY('tevent',
                          SRC,
                          deps='replace talloc',
                          enabled= not bld.CONFIG_SET('USING_SYSTEM_TEVENT'),
                          includes='.',
                          abi_directory='ABI',
                          abi_match='tevent_* _tevent_*',
                          vnum=VERSION,
                          public_headers='tevent.h',
                          public_headers_install=not private_library,
                          pc_files='tevent.pc',
                          private_library=private_library)

    if not bld.CONFIG_SET('USING_SYSTEM_PYTEVENT'):
        bld.SAMBA_PYTHON('pytevent',
                         'pytevent.c',
                         deps='tevent',
                         realname='_tevent.so',
                         cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)
        # install out various python scripts for use by make test
        bld.SAMBA_SCRIPT('tevent_python',
                         pattern='tevent.py',
                         installdir='python')

        bld.INSTALL_WILDCARD('${PYTHONARCHDIR}', 'tevent.py', flat=False)


def test(ctx):
    '''test tevent'''
    print("The tevent testsuite is part of smbtorture in samba4")


def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)

=== debian/changelog ===
samba4 (4.0.3+dfsg1-0.1ubuntu3) trusty; urgency=low

  * Convert some samba4* packages to dummy transitional packages to samba.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Wed, 27 Nov 2013 17:19:26 +0000

samba4 (4.0.3+dfsg1-0.1ubuntu2) trusty; urgency=low

  * No change rebuild for new bind9.

 -- Stéphane Graber <stgraber@ubuntu.com>  Mon, 21 Oct 2013 16:22:41 -0400

samba4 (4.0.3+dfsg1-0.1ubuntu1) saucy; urgency=low

  * Sync with Debian. Remaining change:
    - d/p/underlinking: link samba4kpasswd and samba4kgetcred with -lasn1 to
      fix FTBFS.
  * d/p/fix-pidl-build-with-gcc-48:
    - Backport patch to fix build failure with gcc 4.8

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 16 Jun 2013 18:15:11 -0400

samba4 (4.0.3+dfsg1-0.1) experimental; urgency=low

  [ Andrew Bartlett ]
  * Non-maintainer upload.
  * New upstream relese: 4.0.3
   + Fixes CVE-2013-0172 Samba 4.0.0 as an AD DC may provide authenticated users
     with write access to LDAP directory objects
   + Fixes many other ACL related issues in the AD DC
   + Drop 08_waf_python_config as it is now upstream.
  * Fix the forced use of NTVFS by setting the required options in the smb.conf
    at configure time.
  * Add depenencies to ensure python-samba requires exactly this binary version
    of our core libraries. Closes: #700348

 -- Andrew Bartlett <abartlet@samba.org>  Sat, 16 Feb 2013 17:06:34 +0100

=== debian/control ===
Source: samba4
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Samba Debian Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
           Christian Perrier <bubulle@debian.org>,
           Noèl Köthe <noel@debian.org>,
           Steinar H. Gunderson <sesse@debian.org>,
           Jelmer Vernooij <jelmer@debian.org>
Homepage: http://www.samba.org/
Standards-Version: 3.9.3
Build-Depends: bison,
               comerr-dev,
               debhelper (>> 9),
               docbook-xml,
               docbook-xsl,
               flex,
               heimdal-multidev (>= 1.6~),
               libattr1-dev,
               libacl1-dev,
               libblkid-dev,
               libbsd-dev,
               libgnutls-dev,
               libheimntlm0-heimdal (>= 1.6~),
               libldap2-dev,
               libldb-dev (>= 1:1.1.15~),
               libpam0g-dev,
               libparse-yapp-perl,
               libpopt-dev,
               libreadline-dev,
               libsubunit-dev,
               libtalloc-dev (>= 2.0.8~),
               libtdb-dev (>= 1.2.11~),
               libtevent-dev (>= 0.9.17~),
               libwbclient-dev,
               perl,
               perl-modules,
               pkg-config,
               po-debconf,
               python-all-dev (>= 2.6.6-3),
               python-dnspython,
               python-ldb (>= 1:1.1.13~),
               python-ldb-dev (>= 1:1.1.13~),
               python-talloc-dev (>= 2.0.7~),
               python-tdb (>= 1.2.10~),
               python-testtools,
               samba-common (>= 2:3.4.0~pre2),
               subunit (>= 0.0.6),
               xsltproc,
               zlib1g-dev (>= 1:1.2.3)
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-samba/samba4.git
Vcs-Git: git://git.debian.org/pkg-samba/samba4
XS-Testsuite: autopkgtest

Package: samba4
Architecture: any
Depends: samba (>= 2:4.0.10)
Description: dummy transitional package for samba 4.x series
 A dummy transitional package for renamed samba4 package.
 .
 This package can be safely removed

Package: libsamdb0
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Depends: ${ldb:Depends}, ${misc:Depends}, ${shlibs:Depends}
Conflicts: samba-ldb-tools
Replaces: samba-ldb-tools
Recommends: samba-dsdb-modules
Description: SAM database
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the library for accessing the SAM database.

Package: libsamdb-dev
Architecture: any
Section: libdevel
Depends: libsamdb0 (=${binary:Version}), pkg-config, ${misc:Depends}
Description: SAM database - development files
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the files required for development.

Package: libsamba-policy0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${ldb:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Samba policy management
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the library for policy management.

Package: libsamba-policy-dev
Architecture: any
Section: libdevel
Depends: libsamba-policy0 (=${binary:Version}), pkg-config, ${misc:Depends}
Description: Samba policy management - development files
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the files required for development using the policy
 management library.

Package: samba4-common-bin
Architecture: any
Depends: samba-common-bin (>= 2:4.0.10)
Description: dummy transitional package for samba 4.x series
 A dummy transitional package for renamed samba4 package.
 .
 This package can be safely removed

Package: samba4-clients
Architecture: any
Depends: smbclient  (>= 2:4.0.10)
Description: dummy transitional package for samba 4.x series
 A dummy transitional package for renamed samba4 package.
 .
 This package can be safely removed

Package: samba4-testsuite
Architecture: any
Depends: samba-testsuite (>= 2:4.0.10)
Description: dummy transitional package for samba 4.x series
 A dummy transitional package for renamed samba4 package.
 .
 This package can be safely removed

Package: registry-tools
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: libparse-pidl-perl
Architecture: any
Depends: libparse-yapp-perl, ${misc:Depends}, ${perl:Depends}
Recommends: libdcerpc-dev
Section: perl
Description: IDL compiler written in Perl
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the IDL (Interface Description Language) compiler pidl,
 which takes in IDL files and can output C code for various uses. It is
 primarily of interest to developers.

Package: samba4-dev
Architecture: any
Depends: libc6-dev,
         libldb-dev,
         libparse-pidl-perl,
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev (>= 1.2.11),
         ${misc:Depends}
Section: devel
Description: tools for extending Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains include files shared by the various Samba-based
 libraries.

Package: libgensec0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: samba-common (>= 2:3.4.0~pre2-1), ${misc:Depends}, ${shlibs:Depends}
Replaces: winbind4 (<< 4.0.0~alpha17~git20110724.dfsg1-1)
Description: Generic Security Library
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This library provides a generalized API for several security protocols.

Package: libgensec-dev
Architecture: any
Section: libdevel
Replaces: samba4-dev (<< 4.0.0~alpha17~)
Depends: libgensec0 (=${binary:Version}), pkg-config, ${misc:Depends}
Description: Generic Security Library
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This library provides a generalized API for several security protocols.
 .
 This package contains the files required for development.

Package: libndr0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: NDR marshalling library
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the library for encoding and decoding data structures
 using the Network Data Representation format as used by DCE/RPC.

Package: libndr-dev
Architecture: any
Section: libdevel
Depends: libndr0 (=${binary:Version}), pkg-config, ${misc:Depends}
Description: NDR marshalling library - development files
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the library for encoding and decoding data structures
 using the Network Data Representation format as used by DCE/RPC.
 .
 This package contains the files required for development.

Package: libndr-standard0
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Replaces: libsamba-util0 (<< 4.0.0~alpha17~git20110724.dfsg1-1),
          libsmbclient-raw0 (<< 4.0.0~alpha18-1)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Standard NDR interfaces
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains NDR encoders/decoders for the set of standard
 DCE/RPC interfaces found on Windows and Samba servers.

Package: libndr-standard-dev
Architecture: any
Section: libdevel
Depends: libndr-standard0 (=${binary:Version}), pkg-config, ${misc:Depends}
Replaces: libsmbclient-raw-dev (<< 4.0.0~alpha18-1)
Description: Standard NDR interfaces - development files
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains NDR encoders/decoders for the set of standard
 DCE/RPC interfaces found on Windows and Samba servers.
 .
 This package contains the files required for development.

Package: libdcerpc0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libgensec0 (<< 4.0.0~alpha17~git20110724.dfsg1-1)
Description: DCE/RPC client library
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,

=== debian/rules ===
#!/usr/bin/make -f
# By Jelmer Vernooij <jelmer@samba.org>
#
DESTDIR = $(CURDIR)/debian/tmp

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

PYVERS=$(shell pyversions -vr)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LDB_VERSION = $(shell pkg-config --modversion ldb)
LDB_NEXT_VERSION = $(shell python -c "x = '$(LDB_VERSION)'.split('.'); x[-1] = str(int(x[-1])+1); print '.'.join(x)")
LDB_DEPENDS = "libldb1 (<< 1:$(LDB_NEXT_VERSION)~), libldb1 (>> 1:$(LDB_VERSION)~)"
export PYTHON=$(shell which `pyversions -d`)
export PYTHON_CONFIG="$(PYTHON)-config"
WAF = $(PYTHON) ./buildtools/bin/waf

# turn DEB_BUILD_OPTIONS='foo,bar' into DEB_BUILD_OPT_FOO and DEB_BUILD_OPT_BAR
d_b_o:=$(shell echo "$$DEB_BUILD_OPTIONS"|sed 's/[^-[:alnum:]]/ /g'|tr a-z A-Z)
$(foreach o, $(d_b_o), $(eval DEB_BUILD_OPT_$o := 1))

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
WAF += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

%:
	dh $* --with python2

override_dh_auto_configure:
	$(shell dpkg-buildflags --export=configure) $(WAF) configure \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--with-piddir=/var/run \
		--with-modulesdir=/usr/lib/$(DEB_HOST_MULTIARCH)/samba/ \
		--disable-rpath \
		--disable-ntdb \
		--disable-rpath-install \
		--bundled-libraries=NONE,pytevent,iniparser \
		--builtin-libraries=replace,ccan \
		--private-libraries=smbclient \
		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--enable-fhs

override_dh_auto_clean:
	-$(WAF) clean
	rm -f debian/*.upstart
	find . -name "*.pyc" | xargs rm -f
	rm -rf buildtools/bin/.waf-*

override_dh_auto_install:
	DESTDIR="$(DESTDIR)" $(WAF) install

override_dh_auto_build:
	DESTDIR="$(DESTDIR)" $(WAF)

override_dh_auto_test:
	# Running make test requires configuration with --enable-selftest, which
	# we don't want to do for production systems.

override_dh_install:
	# Alternatives are used
	# Already provided by libparse-yapp-perl
	rm $(DESTDIR)/usr/share/perl5/Parse/Yapp/Driver.pm
	# Already shipped in samba-common
	rm $(DESTDIR)/usr/share/samba/codepages/*.dat
	# Binaries not ready for installation
	rm $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/mit_samba.so
	# Included in python-tevent
	rm $(DESTDIR)/usr/lib/python*/*-packages/_tevent.so
	rm $(DESTDIR)/usr/lib/python*/*-packages/tevent.py
	# Already included in various system packages
	rm -r $(DESTDIR)/usr/lib/python*/*-packages/samba/external
	# Already documented in debian/copyright
	rm $(DESTDIR)/usr/share/samba/setup/ad-schema/licence.txt
	# System ldb loads its modules from a different path
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb
	ln -sf ../../../samba/ldb $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb/samba
	mkdir -p $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/security
	mkdir -p $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/security/pam_winbind.so $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/security/pam_winbind.so
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libnss_winbind.so* $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)
	rm $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/samba/share/ldb.so
	rm $(DESTDIR)/usr/share/samba/codepages/*.msg
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/plugin/krb5
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/winbind_krb5_locator.so \
	   $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/plugin/krb5
	install -m 0755 debian/setoption.py $(DESTDIR)/usr/share/samba
	install -m 0755 debian/addshare.py $(DESTDIR)/usr/share/samba
	# Remove Samba 3 files for now
	while read line; \
	do \
		rm -r $(DESTDIR)$$line; \
	done < debian/samba3-files
	rm -f $(DESTDIR)/usr/share/man/man8/vfs_*.8
	while read line; \
	do \
		rm -r $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/$$line; \
	done < debian/samba3-files-lib
	dh_install --sourcedir=$(DESTDIR) --list-missing

override_dh_python2:
	dh_python2 --no-guessing-versions

get-packaged-orig-source:
	./debian/build-orig.sh

override_dh_installdocs:
	dh_installdocs source4/NEWS

override_dh_shlibdeps:
	LD_LIBRARY_PATH=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/samba:$$LD_LIBRARY_PATH dh_shlibdeps -a

override_dh_gencontrol:
	dh_gencontrol -a -- -Vldb:Depends=$(LDB_DEPENDS)

override_dh_makeshlibs:
	dh_makeshlibs -X/usr/lib/$(DEB_HOST_MULTIARCH)/samba -X/usr/lib/$(DEB_HOST_MULTIARCH)/plugin

override_dh_installinit:
	if dpkg-vendor --derives-from ubuntu; then \
		cp debian/samba4.upstart.in debian/samba4.upstart; \
		dh_installinit --upstart-only; \
	else \
		dh_installinit; \
	fi;
